
C      IMPLICIT REAL*8 (A-H,O-Z)
C WE USE THIS PROGRAM TO GENERATE DATA FOR THE INSTRUMENTAL VARIABLES
C ESTIMATION
      parameter (mxn=610,ms=27,ITRUNC=2,ITYP=2,IILIVS=2)
C ILIVS=1 GER LIVSCYKELMODELL; ILIVS=2 GER ATEMPORAL MODELL.
C ITRUNC=1 GER LITET SAMPLE; ITRUNC=2 GER STORT SAMPLE
C Y=VIRTUELL INK(MILLIONTALS KR),HL=KNCKPUNKT,XNC=ANT. BARN,AGE=LDER,
C NS=ANTAL SEGMENT, NK=ANTAL KNCKPUNKTER
C H=ANTAL ARBETSTIMMAR(TUSENTAL),W=LUTNING P BUDGETSEGMENT (KR)
      DIMENSION Y(mxn,ms),HL(mxn,ms),XNC(mxn),AGE(mxn),NS(mxn),WG(MXN),
     1YVIRT(MXN),WNET(MXN),YCOMB(MXN),spar(mxn),YTSQ(MXN),YNTSQ(MXN),
     2WGSQ(MXN),YT(MXN),YNT(MXN),XU22(MXN),XU23(MXN),XU73(MXN),
     3XU93(MXN),XU94(MXN),XU95(MXN),XU123(MXN),XU138(MXN),XU710(MXN)
      DIMENSION H(mxn) ,W(mxn,ms)
      COMMON/DAATA/H,W,Y,HL,XNC,AGE,SPAR,XU22,XU23,XU73,XU123,XU138,
     1XU710,XU93,XU94,XU95
      COMMON/IVDATA/WG,YVIRT,WNET,YT,YNT
      COMMON/BJORN/N,NS
      COMMON/TYP/IITYP,ILIVS
      COMMON/TRUN/IITRUNC
      REAL MEDUC2,MEDUC3,MEDUC4,MEDUC5,MEDUC6,MEDUC7,MEDUC8
      IITRUNC=ITRUNC
      IITYP=ITYP
      ILIVS=IILIVS
C BUDGET LSER IN DATA OCH BERKNAR LUTNINGAR,VIRTUELL INKOMST ETC
      CALL BUDGET
      DO 10 I=1,50
      WRITE(*,*) 'EDU',XU138(I)
10    CONTINUE
C
C N=ANTAL OBS.
      OPEN(7,FILE='IVDAT',STATUS='OLD')
C WE NOW LINEARIZE AROUND OBSERVED POINTS
      DO 100 I=1,N
      DO 80 J=1,NS(I)
      IF (HL(I,J) .GT. H(I)) THEN
      YVIRT(I)=Y(I,J)*1000.0
      WNET(I)=W(I,J)
      GO TO 85
      ENDIF
80    CONTINUE
85    CONTINUE
      WGSQ(I)=WG(I)*WG(I)
      YTSQ(I)=YT(I)*YT(I)
      YCOMB(I)=YT(I)+YNT(I)
      YNTSQ(I)=YNT(I)*YNT(I)
C WE NOW CONSTRUCT THE DUMMY FOR EDUCATION
        EDUC2=0.0
        EDUC3=0.0
        EDUC4=0.0
        EDUC5=0.0
        EDUC6=0.0
        EDUC7=0.0
        EDUC8=0.0
        WRITE(*,*) 'ED=',XU138(I)
        IF(ABS(XU138(I)-2.0).LT. 0.1 .OR.ABS(XU138(I)-9.0).LT.0.1) THEN
           EDUC2=1.0
          ELSE IF (ABS(XU138(I)-3.0) .LT. 0.1) THEN
           EDUC3=1.0
          ELSE IF (ABS(XU138(I)- 4.0).LT. 0.1) THEN
           EDUC4=1.0
          ELSE IF (ABS(XU138(I)- 5.0).LT.0.1) THEN
           EDUC5=1.0
          ELSE IF (ABS(XU138(I)- 6.0).LT.0.1) THEN
           EDUC6=1.0
          ELSE IF (ABS(XU138(I)- 7.0).LT.0.1) THEN
           EDUC7=1.0
          ELSE IF (ABS(XU138(I)-8.0).LT.0.1) THEN
           EDUC8=1.0
        ENDIF
C WE NOW CONSTRUCT THE DUMMY FOR WIFES EDUCATION
        WEDUC2=0.0
        WEDUC3=0.0
        WEDUC4=0.0
        WEDUC5=0.0
        WEDUC6=0.0
        WEDUC7=0.0
        WEDUC8=0.0
        IF(ABS(XU123(I)-2.0).LT.0.1 .OR. ABS(XU123(I)-9.0).LT.0.1) THEN
           WEDUC2=1.0
          ELSE IF (ABS(XU123(I)-3.0).LT.0.1) THEN
           WEDUC3=1.0
          ELSE IF (ABS(XU123(I)- 4.0).LT.0.1) THEN
           WEDUC4=1.0
          ELSE IF (ABS(XU123(I)- 5.0).LT.0.1) THEN
           WEDUC5=1.0
          ELSE IF (ABS(XU123(I)- 6.0).LT.0.1) THEN
           WEDUC6=1.0
          ELSE IF (ABS(XU123(I) - 7.0) .LT. 0.1) THEN
           WEDUC7=1.0
          ELSE IF (ABS(XU123(I) -8.0) .LT. 0.1) THEN
           WEDUC8=1.0
        ENDIF

C WE NOW CONSTRUCT A DUMMY FOR FATHERS EDUCATION.
      FEDUC2=0.0 
      FEDUC3=0.0
      FEDUC4=0.0
      FEDUC5=0.0
      IF(ABS(XU22(I) - 11.0) .LT. 0.1) THEN
         FEDUC2=1.0
       ELSE IF (ABS(XU22(I) - 12) .LT. 0.1) THEN   
         FEDUC3=1.0
       ELSE IF (ABS(XU22(I) - 13) .LT. 0.1) THEN
         FEDUC4=1.0
       ELSE IF (ABS(XU22(I) - 14) .LT. 0.1) THEN
        FEDUC5=1.0
      ENDIF
C WE NOW CONSTRUCT A DUMMY FOR MOTHERS EDUCATION.
      MEDUC2=0.0 
      MEDUC3=0.0
      MEDUC4=0.0
      MEDUC5=0.0
      IF(ABS(XU23(I) - 11.0) .LT. 0.1) THEN
         MEDUC2=1.0
       ELSE IF (ABS(XU23(I) - 12) .LT. 0.1) THEN   
         MEDUC3=1.0
       ELSE IF (ABS(XU23(I) - 13) .LT. 0.1) THEN
         MEDUC4=1.0
       ELSE IF (ABS(XU23(I) - 14) .LT. 0.1) THEN
        MEDUC5=1.0
      ENDIF
      HOME=0.0
      IF(ABS(XU73(I) - 10.0).LT.0.1) HOME=1.0
      ORT1=0.0
      ORT2=0.0
      IF(XU710(I) .LT. 4.0 ) ORT1=1.0
      IF(XU710(I) .GT. 4.0) ORT2=1.0
      U93=XU93(I)
      U94=XU94(I)
      U95=XU95(I)
      WRITE(7,90) H(I),WG(I),WGSQ(I),YT(I),YTSQ(I),YNT(I),YNTSQ(I),
     1YCOMB(I),WNET(I),YVIRT(I),EDUC2,EDUC3,EDUC4,EDUC5,EDUC6,EDUC7,
     2EDUC8,WEDUC2,WEDUC3,WEDUC4,WEDUC5,WEDUC6,WEDUC7,WEDUC8,FEDUC2,
     3FEDUC3,FEDUC4,FEDUC5,MEDUC2,MEDUC3,MEDUC4,MEDUC5,HOME,ORT1,ORT2,
     4U93,U94,U95,AGE(I)
90    FORMAT(F5.2,1X,F6.2,1X,F8.2,1X,F5.0,1X,F6.0,1X,F4.0,1X,F6.0,1X,
     1F5.0,1X,F5.2,1X,F4.0,(25(1X,F2.0)),(4(1X,F4.0)))
100   CONTINUE
      GO TO 800
800   CONTINUE
      WRITE(*,*) 'HR R N=',N
      CLOSE(7)
      STOP
      END
C
*********************************************************************
       SUBROUTINE BUDGET
C       implicit real*8 (A-H,O-Z)
       CHARACTER*(*) DATAFIL
       PARAMETER (DATAFIL='SOREN5.DAT',MXN=610,MS=27)
       COMMON/DAATA/H,W,Y,HL,XNC,AGE,SPAR,XU22,XU23,XU73,XU123,XU138,
     1XU710,XU93,XU94,XU95
       COMMON/IVDATA/WG,YVIRT,WNET,YT,YNT
       COMMON/BJORN/N,NS
        COMMON/TYP/IITYP,ILIVS
      COMMON/TRUN/IITRUNC
       INTEGER A,B
       DIMENSION H(MXN), AGE(MXN), BB(MXN),XNC(MXN),SPAR(MXN),NS(MXN)
       DIMENSION WG(MXN),YVIRT(MXN),WNET(MXN),YT(MXN),YNT(MXN)
       DIMENSION WX(MS),YX(MS),HX(MS),Y(MXN,MS),W(MXN,MS),HL(MXN,MS)
       DIMENSION XU22(MXN),XU23(MXN),XU73(MXN),XU123(MXN),XU138(MXN),
     1XU710(MXN),XU93(MXN),XU94(MXN),XU95(MXN)
      REAL UBNR,U11,U22,U23,U73,U93,U94,U95,
     1U104,U105,U106,U123,U137,U138,U283,U443,U710,UU87,R40,R43,R50,
     2R51,R126,R130,R167,R168,R169,R195,R208,R211,R215,R262,R270,R287,
     3M40,M43,M50,M126,M130,M208,M211,M215,M262,M270,M277,M286,M287,M290
        B=0
        N=640
        OPEN(UNIT=1,FILE=DATAFIL,FORM='FORMATTED',
     *       ACCESS='SEQUENTIAL',STATUS='OLD')
C LS IN DATA FR RESPEKTIVE INDIVID
C KSK AR KOPESKILLINGSKOEFFICIENT FOR SMAHUS
C R R RANTEFAKTOR
        Y1=0.0
      DO 80 A=1,N
      READ(UNIT=1,FMT=10,END=110) UBNR,U11,U22,U23,U73,U93,U94,U95,
     1U104,U105,U106,U123,U137,U138,U283,U443,U710,UU87,R40,R43,R50,
     2R51,R126,R130,R167,R168,R169,R195,R208,R211,R215,R262,R270,R287,
     3M40,M43,M50,M126,M130,M208,M211,M215,M262,M270,M277,M286,M287,M290
10    FORMAT(F5.0,10F2.0,F1.0,F2.0,F1.0,F3.0,F5.0,F1.0,F5.0,6F7.0,2F4.0,
     1F3.0,F6.0,3F7.0,F5.0,F6.0,F5.0,8F7.0,F5.0,2F6.0,3F5.0)
C
        IF(U283.EQ.0.OR.U283.EQ.999.OR.R195.EQ.0 .OR. U138 .EQ. 9)
     1  GO TO 80
        IF(U443.LE.0.OR.U443.EQ.9999.OR.UU87.EQ.99999) GOTO 80
        IITRUNC=2
        IF(IITRUNC.EQ.1.AND.(R215+M215.EQ.0.0.OR.R130+M130.EQ.0.0))
     *  GO TO 80
        B=B+1
        H(B)=U283*10.
        AGE(B)=0.0
        ALDER=81.0-U11
        IF(ALDER.GE.45) AGE(B)=1.
        XW=U443*(1/1.092)
        WG(B)=XW
        XMDI=M277+28.5*(U104+U105)+(R287+M286+M287
     *  -M290)/10.
        XMDI=XMDI*100.
        XNC(B)=U93+U94+U95
        XIT=R195*100.
        FTI=R208*100.
        BBM=R262+M262
        FTI78=R43*100.
        FTIM78=M43*100.
        YEM=M208*100.
        E=(R40+M40)*100.
        W78=(R50+M50+R51)*100.
        XU22(B)=U22
        XU23(B)=U23
        XU73(B)=U73
        XU93(B)=U93
        XU94(B)=U94
        XU95(B)=U95
        XU123(B)=U123
        XU138(B)=U138
        XU710(B)=U710
        U87=UU87
        TK=(R167+R168+R169)/10000.
        SINK=M277*100.
        STUDM=(M286+M287-M290)*10.
        SINK80=R270*100.
        SINKM80=M270*100.
        CAPIN=FTI-XIT
        YT(B)=CAPIN/1000.0
        YNT(B)=XMDI/1000.0
        CALL INTERTEM(R215,M215,R211,M211,R130,M130,
     *  R126,M126,CAPIN,SAVE,FTI,XIT)
        SAVVE=SAVE
C  ANROP P NYBUDGET SOM BERKNAR VIRTUELL INK., LUTNINGAR ETC.
        CALL NYBUDGET(B,XW,XMDI,XIT,FTI,FTI78,FTIM78,W78,E,XNC(B),
     *YEM,U87,BBF,NSX,WX,YX,HX,TK,SINK80,SIMBB,YB,SINKM80,CAPIN)
        NS(B)=NSX
        H(B)=H(B)/1000.
        IF(ILIVS .EQ. 2) SAVE=0.0
        SPAR(B)=SAVE/1000000.
        DO 50 I=1,NSX
        W(B,I)=WX(I)
        Y(B,I)=YX(I)/1000000.
        Y(B,I)=Y(B,I)-SPAR(B)
50      HL(B,I)=HX(I)/1000.
C WE NOW TEST THAT THERE EXISTS A FEASIBLE CONSUMPTION POINT. IF THERE DOES
C NOT EXIST A FEASIBLE CONSUMPTION POINT WE EXCLUDE THE OBSERVATION.
        Y8760=1.0D6*Y(B,NSX)+W(B,NSX)*8760.0
        ISIGN=(-1)**(ILIVS+1)
        YY8760=Y8760+ISIGN*SAVVE
C        IF(Y8760 .LE. 0.0 .OR. YY8760 .LE. 0.0) B=B-1
        WRITE(*,*) 'EDD',XU138(B)
80      CONTINUE
110     CONTINUE
        CLOSE(UNIT=1,STATUS='KEEP')
        N=B
        XN=N
        SPARBAR=0.0D0
        DO 300 I=1,N
        SPARBAR=SPAR(I)+SPAR(I)/XN
300     CONTINUE
        WRITE(*,*) SPARBAR,'     N=',N

        RETURN
        END
C
      SUBROUTINE NYBUDGET(B,XW,XMDI,XIT,FTI,FTI78,FTIM78,W78,E,XNC,
     *YEM,U87,BBF,NSX,WX,YX,HX,TK,SINK80,SIMBB,YB,SINKM80,CAPIN)
C      IMPLICIT REAL*8 (A-H,O-Z)
       PARAMETER (MGB=5,MXN=610,MS=27,MSP1=28,MSM5=22,MGBP1=6,MSM1=26)
      COMMON/TYP/IITYP,ILIVS
      INTEGER B
C PROGRAMMET BERKNAR FRST LUTNINGAR, VIRTUELLA INKOMSTER
C OCH SEGMENTSGRNSER P BUDGETRESTRIKTIONEN D HNSYN ENBART
C TAS TILL 1980 RS SKATTER. SEDAN BERKNAS OVANSTENDE D
C HNSYN TAS TILL BOSTADSBIDRAGEN 1980 ( DET EXTRA-KOMMUNALA
C BIDRAGET I STOCKHOLM TAS DOCK INTE MED).
C SLUTLIGEN BERKNAS BOSTADSBIDRAGETS STORLEK VID SEGMENTS-
C GRNSERNA FR ANTALET ARBETSTIMMAR
C
C
C WX, YX OCH HX R LUTNING, VIRTUELL INK. OCH SEGM.GRNS:
C
      DIMENSION WX(MS),YX(MS),HX(MS)
      DIMENSION TSBAR(MS)
C
C W,Y,HL R IDENTISKT LIKA MED WX,YX,HX (SKILLNADEN R ATT DE FRRA
C KOMMER INDEXERAS FR VARJE INDIVID NR DETTA PROGRAM SENARE AN-
C VNDS SOM EN SUBRUTIN). C R 'HICKSIAN COMPOSITE' VARA.
C
      DIMENSION W(MS), Y(MS),HL(MS),C(MSP1),TST(0:MSM5)
C
C G R SEGMENTGRNS FR TAXERAD INKOMST M.H.T ENBART SKATT
C T R MARGINALSKATT INOM RESPEKTIVE SKIKT=KOMMUNAL SKATTESATS,TK,
C SOM VARIERAR MELLAN INDIVIDERNA PLUS STATLIG SKATTESATS,TST.
C GB R SEGMENTGRNS UTTRYCKT I TAXERAD INK. FR BOSTADSBIDRAG
C TB R MARGINALEFFEKT AV BOSTADSBIDRAG INOM RESPEKTIVE GB SKIKT
C GS R SEGMENTGRNS UTTRYCKT I TAXERAD INKOMST NR HNSYN TAS TILL
C BDE SKATT OCH BOSTADSBIDRAG.
C TS R TOTAL MARGINALEFFEKT INOM RESPEKTIVE GS SKIKT
C
      DIMENSION G(0:MSM5),T(0:MSM5),GB(0:MGB),TB(MGBP1),GS(MSM1),TS(MS)
C
C TAXB R REDUKTION AV BOSTADSBIDRAG VID TB SKIKTETS UNDRE GRNS
C TAXS R SUMMAN AV SKATT OCH REDUKTION AV BOSTADSBIDRAG VID TS
C SKIKTETS UNDRE GRNS.
C
      DIMENSION  TAXB(MGBP1),TAXS(MS)
C
      DATA G/0.0,6832.,23200.,29000.,34800.,40000.,40600.,45000.,
     *46400.,52200.,58000.,60000.,63800.,69600.,75400.,76600.,81200.,
     *87000.,92800.,98600.,116000.,174000.,1.D10/
      DATA TST/0.0,0.0,0.02,0.04,0.05,0.08,-0.02,0.01,0.11,0.14,0.20,
     *0.22,0.25,0.29,0.33,0.37,0.34,0.39,0.44,0.45,0.48,0.53,0.58/
C
      MTST=MS-5
C
C LS IN MANNENS OCH MAKANS TAX.INK (FTI),FRMGENHET 1978 (W78),
C UNDERSKOTTSAVDRAG 1978 (E),ANTAL BARN (XNC) OCH NETTOBOSTADS-
C KOSTNAD (U87).
C YB=BIDRAGSGRUNDANDE INKOMST BASERAD P INKOMST 1978
C U87G=GRNSER FR BOSTADSKOSTNADEN VID BERKNING AV BOSTADSBIDR. (BB)
C BB=SAMMANLAGT BOSTADSBIDRAG
C YEM=MAKANS AKTUELLA INKOMST 1980 (TAXERAD INKOMST)
C FTI78=MANNENS TAXERADE INKOMST 1978
C FTIM78=MAKANS TAXERADE INKOMST 1978
C XW=BRUTTOTIMLN
C XIT=MANNENS INK AV TJNST 1980
C BBM=FAKTISKT UTBETALT BB
C TK=KOMMUNALSKATTESATS
C SINK80=SAMMANRKNAD INK 1980
C
C
c
        GB(0)=0.0
        BB=0.0
C BERKNA MARGINALSKATT,T:
        T(0)=TST(0)
        T(1)=TST(1)
        DO 33 I=2,MTST
        T(I)=TST(I)+TK
33      CONTINUE
C MARGINALSKATTESPRR:
        DO 34 I=MTST-2,MTST-1
        IF(T(I).GT.0.80) T(I)=0.80
34      CONTINUE
        IF(T(MTST).GT.0.85) T(MTST)=0.85
C
C
C BERKNA BIDRAGSGRUNDANDE INKOMST BASERAD P INKOMST 1978 (YB)
        YB=FTI78+FTIM78
        IF(W78.GE.75000.) THEN
        YB=YB+(W78-75000.)*0.2
        ENDIF
        IF( E .GE. 4000. )THEN
        YB=YB+E-4000.
        ENDIF
C
C BERKNA STATLIGT BOSTADSBIDRAG:
        SBB=1500.*XNC
C
C BERKNA OREDUCERAT STATSKOMMUNALT BOSTADSBIDRAG SKBB:
        U87G=800.
        IF( XNC.EQ.1. .OR. XNC.EQ.2. )     U87G=1125.
        IF( XNC.EQ.3. .OR. XNC.EQ.4. )     U87G=1375.
        IF( XNC.GE.5. )     U87G=1625.
        IF( U87 .GE. U87G )     U87=U87G
        SKBB=(U87-450.)*0.8
C
C
C  BERKNA SEGMENTGRNSER UTTRYCKTA I SAMMANRKNAD INK. FR BB (GB)
C  SAMT MARGINALEFFEKT,TB, AV BB
C FLJANDE INTERVALL R MJLIGA FR SAMMANRKNAD INKOMST (VISSA INTERV.
C UTESLUTER ANDRA  - 5 INTERVALL R SAMTIDIGT MJLIGA) INTERVALLEN
C GLLER FR HUSHLL SOM HAR BARN. FR HUSHLL UTAN BARN SKA
C 33000 OCH 38000 ERSTTAS MED 24000 OCH 29000:
C
C INTERVALL:                MARGINALEFFEKT AV BOSTADSBIDRAG:
C 0 - (MIN(YB,38000)-5000)                                0
C 33000 - (MIN(YB,59000)-5000)                           15
C 54000 - (YB-5000)                                      24
C (YB+20000) - 58000                                      0
C (MAX(YB,38000)+20000) - 79000                          15
C (MAX(YB,59000)+20000) -                                24
C (YB-5000) - (YB+20000)-                                 0
C
C INTERVALLET (YB-5000)-(YB+20000) FREKOMMER ALLTID. OM YB R
C STRRE/MINDRE N GRNSERNA 38000 OCH 59000 (MINSKAS GRNSEN MED
C 5000)/(KAS GRNSEN MED 20000)
       TB(1)=0.0
       TB(5)=0.24
C OM HUSHLLET INTE HAR BARN:
      IF( XNC.EQ.0.0 )THEN
          BB=SKBB*12
          G1=29000.
          G2=59000.
C
C OM HUSLLET HAR BARN:
        ELSEIF( XNC.GT.0.0 )THEN
        BB=SBB+SKBB*12
        G1=38000.
        G2=59000.
      ENDIF
      IF(YB.LT.G1) THEN
        GB(1)=YB-5000.
        GB(2)=YB+20000.
        GB(3)=G1+20000.
        GB(4)=G2+20000.
        TB(2)=0.0
        TB(3)=0.0
        TB(4)=0.15
      ELSEIF(YB.GE.G1.AND.YB.LT.G2) THEN
        GB(1)=G1-5000.
        GB(2)=YB-5000.
        GB(3)=YB+20000.
        GB(4)=G2+20000.
        TB(2)=0.15
        TB(3)=0.0
        TB(4)=0.15
      ELSEIF(YB.GE.G2) THEN
        GB(1)=G1-5000.
        GB(2)=G2-5000.
        GB(3)=YB-5000.
        GB(4)=YB+20000.
        TB(2)=0.15
        TB(3)=0.24
        TB(4)=0.0
      ENDIF
C NU R BERKNINGEN AV SEGMENTGRNSER OCH MARGINALEFFEKT AV BB KLAR
C
C
C AVRUNDNINGSREGEL:
        IF((BB/12.).LE.20.)  BB=0.0
C
C
C BERKNA REDUKTION AV BOSTADSBIDRAG VID SKIKTETS UNDRE GRNS:
        TAXB(1)=0.0
        DO 2015 I=1,4
        TAXB(I+1)=(GB(I)-GB(I-1))*TB(I)+TAXB(I)
2015    CONTINUE
C
C
C BBF R OREDUCERAT BOSTADSBIDRAG
        BBF=BB
C
C KORRIGERA DEN VERSTA SEGMENTGRNSEN S ATT BB0 VID DENNA
        DO 10 I=3,5
          IF(TAXB(I).GT.BBF) GO TO 1500
10      CONTINUE
        GO TO 1600
1500    GB(I-1)=(BBF-TAXB(I-1))/TB(I-1)+GB(I-2)
900     IF(I.LE.5) THEN
        TB(I)=0.0
        TAXB(I)=BBF
        I=I+1
        GO TO 900
        ENDIF
        GB(5)=GB(4)+100./30.
        GO TO 1000
1600    GB(5)=(BBF-TAXB(5))/0.24+GB(4)
1000    CONTINUE
C
C
C
C SEGMENTGRNSERNA MSTE KORRIGERAS FR MAKANS AKTUELLA INKOMST
C D DE SKA BASERA SIG P  MANNENS AKTUELLA INKOMST:
C DESSUTOM TRANSFORMERAS SEGM.GRNSERNA S ATT DE GLLER FR TAX. INK
C ISTLLET FR SAMMANRKNAD INK.
        BBF1=BBF
C BERKNA BBF MED HNSYN TILL YEM
C BBF SKA VARA FAMILJENS BOSTADSBIDRAG OM MANNENS INKOMST R 0 KR.
        IF( (XNC.EQ.0 .AND. SINKM80.GE.65000.) .OR.
     *     (XNC.EQ. 1.0 .AND. SINKM80 .GE.93000.) .OR.
     *     (XNC.EQ. 2.0 .AND. SINKM80 .GE.100000.) .OR.
     *     (XNC.EQ. 3.0 .AND. SINKM80 .GE.116000.) .OR.
     *     (XNC.EQ. 4.0 .AND. SINKM80 .GE.122000.) .OR.
     *     (XNC.EQ. 5.0 .AND. SINKM80 .GE.138000.) .OR.
     *     (XNC.GE. 6.0 .AND. SINKM80 .GE.155000.) )THEN
        BBF=0.0
        GO TO 3000
        ENDIF
        DO 5000 J=1,MGB-1
        IF(SINKM80.LE.GB(J)) THEN
        BBF=BBF-TAXB(J)-(SINKM80-GB(J-1))*TB(J)
        IF((BBF/12.).LE.20.)  BBF=0.0
        GO TO 6000
        ENDIF
5000    CONTINUE
6000    CONTINUE
        IF(SINKM80.GE.GB(4)) THEN
        BBF=BBF-TAXB(5)-(SINKM80-GB(4))*TB(5)
        IF((BBF/12.).LE.20.)  BBF=0.0
       ENDIF
3000   CONTINUE
       DO 1070 J=1,5
       GB(J)=GB(J)-SINKM80-(SINK80-FTI)
1070   CONTINUE
C
C BBF1-BBF R DEN REDUKTION AV BOSTADSBIDRAG SOM BEROR P MAKANS INK.
      DO 3700 I=1,6
      TAXB(I)=TAXB(I)-(BBF1-BBF)
      IF(TAXB(I).LT.0.0) TAXB(I)=0.0
3700  CONTINUE
C
C SAMSORTERA GB OCH G TILL GS SAMT T OCH TB TILL TS:
      I=1
      J=1
      K=1
20    IF (I.LT.MGB+1) THEN
        IF (GB(I).LT.G(J).OR.J.GT.21) THEN
          GS(K)=GB(I)
          TS(K)=T(J)+TB(I)
          K=K+1
          I=I+1
        ELSE
          GS(K)=G(J)
          TS(K)=T(J)+TB(I)
          K=K+1
          J=J+1
        ENDIF
        GO TO 20
      ENDIF
      IF(K.GT.MS-1) GOTO 31
      DO 30 L=K,MS-1
      GS(L)=G(J)
      TS(L)=T(J)
      J=J+1
30    CONTINUE
31     CONTINUE
      TS(MS)=T(MTST)
C
C
C BERKNA TOTAL SKATT (INKOMSTSKATT+REDUKTION AV BB) VID NEDRE SEGM-
C ENTGRNS
        TAXS(1)=0.0
      DO 1001 I=1,MS-1
       TAXS(I+1)=TS(I)*(GS(I)-GS(I-1))+TAXS(I)
1001    CONTINUE
       IF(IITYP.EQ.3) GO TO 6501
C KONVEXIFIERA BUDGETMANGDEN
         M=0
101     L=0
        DO 102 K=2,MS
        IF(TS(K).LT.TS(K-1)) L=L+1
102     CONTINUE
          IF(L.EQ.0) GO TO 103
       I=3
40     IF(I.GE.MS) GO TO 100
       IF(TS(I).GE.TS(I-1)) THEN
       I=I+1
       GO TO 40
       ELSE
         TSBARR=1.2
          DO 50 K=I,MS-1
          TSBAR(K)=(TAXS(K+1)-TAXS(I-1))/(GS(K)-GS(I-2))
          IF(TSBAR(K).LE.TSBARR) THEN
            TSBARR=TSBAR(K)
            KK=K
          ENDIF
50        CONTINUE
          DO 60 K=I-1,KK
          TS(K)=TSBARR
          TAXS(K+1)=TSBARR*(GS(K)-GS(I-2))+TAXS(I-1)
60        CONTINUE
          I=KK+2
          GO TO 40
       ENDIF
100    CONTINUE
       M=M+1
       IF((M.GT.30).AND.(TS(MS).LT.TS(MS-1))) TS(MS)=TS(MS-1)
       GO TO 101
103    CONTINUE
C
6501    CONTINUE
C BERKNA VIRTUELL INKOMST,LUTNINGAR, ANTAL SEGMENT SAMT SEGMENT-
C GRNSER I ANTAL ARBETSTIMMAR
      CALL BUDGET2(XW,XMDI,FTI,XIT,GS,TS,TAXS,BBF,NSX,WX,YX,HX,CAPIN)
       NS=NSX
       H=H/1000.
       DO 1003 I=1,NSX
       W(I)=WX(I)
       Y(I)=YX(I)/1000.
1003   hl(I)=HX(I)/1000.
C
C BERKNA UTBETALT BOSTADSBIDRAG
        DO 1004 J=1,5
        IF(FTI.LE.GB(J)) THEN
        SIMBB=BBF-TAXB(J)-(FTI-GB(J-1))*TB(J)
        GO TO 1005
        ENDIF
1004    CONTINUE
        SIMBB=0.0
1005    CONTINUE
        RETURN
        END
*********************************************************************
      SUBROUTINE BUDGET2(XW,XMDI,FTI,XIT,GS,TS,TAXS,BBF,NSX,WX,YX,HX,
     *CAPIN)
C      IMPLICIT REAL*8 (A-H,O-Z)
        PARAMETER (MS=27)
      DIMENSION GS(MS),TS(MS),TAXS(MS),WX(MS),YX(MS),HX(MS)
      HBAR=8760.
      X=FTI-XIT
      DO 100 I=1,MS-1
        IF(X.GT.GS(I)) GO TO 100
C NSX R ANTAL SEGMENT
        NSX=MS+1-I
        IF(I.GT.1) GO TO 30
        TX=0.0
        GO TO 35
C  TX = SKATT P 'KAPITAKINK'.
30      TX=TAXS(I)+TS(I)*(X-GS(I-1))
C  YX(1)=VIRTUELL INK. P FRSTA BUDGETSEGMENTET.
35      YX(1)=XMDI+CAPIN-TX+BBF
C  BERKNA LUTNINGAR ,WX:
        DO 40 K=1,NSX
40        WX(K)=XW*(1.0-TS(MS-NSX+K))
        ML=NSX-1
C  BERKNA SEGMENTGRNSER FR ANTALET ARBETSTIMMAR:
        DO 45 K=1,ML
          HX(K)=(GS(MS-1-ML+K)-X)/XW
          IF(HX(K).GT.HBAR) GO TO 46
45      CONTINUE
        GO TO 47
46      NSX=K
47      HX(NSX)=HBAR
        DO 50 K=2,NSX
C  BERKNA VIRTUELL INK. FR VRIGA SEGMENT:
          YX(K)=YX(K-1)+(TS(MS-ML-1+K)-TS(MS-ML-1+(K-1)))*(GS(MS-1
     *    -ML+(K-1))-X)
50     CONTINUE
        GO TO 150
100     CONTINUE
C       THE FOLLOWING IS RIGHT IF X.GT.174000
        NSX=1
        WX(1)=XW*(1.0-TS(MS))
        YX(1)=XMDI+X-TAXS(MS)-TS(MS)*(X-174000.)
        HX(1)=HBAR
150     CONTINUE
        RETURN
        END
*********************************************************************
        SUBROUTINE INTERTEM(R215,M215,R211,M211,R130,M130,R126,M126,
     *  CAPIN,SPAR,FTI,XIT)
C THIS SUBROUTINE CALCLUATES THE ATEMPRAL MEASURE CAPIN, ESSENTIALLY
C CAPITALINCOME CORRECTED FR IMPLICIT AVKASTNING AV EGET HEM, OCH
C ETT SPARANDEMATT, R215+M215=ASSESSED VALUE OF SPOUSES ASSETS,
C R211+M211=GARANTIBELOPPET FR FASTIGHET. VI ANVANDER KOPESKILLINGS
C KOEFFICIENT FOR ATT BERAKNA MARKNADSVARDE.DVS SAVE=A:T- A:T-1.
C        IMPLICIT REAL*8 (A-H,O-Z)
        REAL KSK79,KSK80
        REAL R215,M215,R211,M211,R130,M130,R126,M126
        PARAMETER (KSK79=2.78,KSK80=2.86,R=0.1)
        SPAR=(R215+M215+(KSK80-1)*(R211+M211)/0.02)*100.-
     *          (R130+M130+(KSK79-1)*(R126+M126)/0.02)*100.
C BRAKNA SCHABLONINTAKT FOR MANNN
        TAX80=(R211+M211)*100./0.02
        CAPIN=FTI-XIT
        IF(TAX80.GT.0.0) THEN
        IF(TAX80.LE.200000.) THEN
        SINT=0.03*TAX80
        ELSEIF(TAX80.LE.250000.0.AND.TAX80.GT.200000.) THEN
        SINT=6000.+0.04*(TAX80-200000.)
        ELSEIF(TAX80.LE.300000.0.AND.TAX80.GT.250000.) THEN
        SINT=8000.+0.08*(TAX80-250000.)
        ELSE
        SINT=12000.+0.1*(TAX80-300000.)
        ENDIF
        CAPIN=FTI-XIT+R*(R211+M211)*KSK80*100./0.02-SINT
        ENDIF
        RETURN
        END
